﻿using System;
using System.Collections;
using System.IO;
using System.Reflection;

namespace BuildIndexIssueTest
{
    internal partial class Program
    {
        private static readonly string[] progress = new string[] { "-", "/", "|", "\\" };

        private static void Main(string[] args)
        {
            // if there has parameter, we will igore executing sql step.
            Utils.ExecuteSql(args);

            int index = 0;
            ArrayList list = new ArrayList();

            while (true)
            {
                // this if statement isn't the critical part, just keep the memory low.
                if (index % 10 == 0)
                {
                    index = 0;
                    list.Clear();
                }

                double x = Utils.RandomCoordinate();
                double y = Utils.RandomCoordinate();
                Range range = new Range(x, y);
                list.Add(range);

                try
                {
                    list.Sort(new ComparerRange());
                }
                catch (Exception ex)
                {
                    Utils.TraceException(ex);
                    break;
                }
                index++;
                Console.Write("\r" + progress[index % 4]);
            }

            Console.ReadLine();
        }

        private class ComparerRange : IComparer
        {
            public ComparerRange()
            { }

            public int Compare(object o1, object o2)
            {
                // it works fine when I use this commented code below. 
                // Range ea = (Range)o1;
                // Range eb = (Range)o2;
                IRange ea = (IRange)o1;
                IRange eb = (IRange)o2;

                double a = ea.Min + ea.Max;
                double b = eb.Min + eb.Max;

                return a > b ? 1 : a < b ? -1 : 0;
            }
        }
    }
}