﻿using System;
using System.Data;
using System.Data.OleDb;
using System.IO;
using System.Reflection;

namespace BuildIndexIssueTest
{
    public static class Utils
    {
        private static readonly string provider = "Microsoft.ACE.OLEDB.12.0";
        private static readonly Random r = new Random();

        public static void ExecuteSql(string[] args)
        {
            if (args.Length > 0) return;

            string path = Path.Combine(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location), "AppData", "CoordSys.mdb");
            string sql = "SELECT CoordsysName, SRID, IsProjected, IsCustom, Proj4Params FROM COORDINATE_SYSTEM_LIST WHERE SRID = 26916;";
            string connectionString = GetOleDbCollectionString(path);

            OleDbCommand cmd = null;
            OleDbConnection conn = null;
            OleDbDataReader reader = null;

            try
            {
                conn = new OleDbConnection(connectionString);
                cmd = new OleDbCommand(sql, conn);
                conn.Open();
                reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
            }
            finally
            {
                if (cmd != null) cmd.Dispose();

                if (reader != null)
                {
                    reader.Close();
                    reader.Dispose();
                }

                if (conn != null)
                {
                    conn.Close();
                    conn.Dispose();
                }
            }
        }

        public static void TraceException(Exception ex)
        {
            Console.WriteLine(ex.Message);
            Console.WriteLine(ex.StackTrace);
        }

        public static double RandomCoordinate()
        {
            return r.NextDouble() * 180d - 180d;
        }

        private static string GetOleDbCollectionString(string path)
        {
            OleDbConnectionStringBuilder oBuilder = new OleDbConnectionStringBuilder();
            oBuilder.DataSource = path;
            oBuilder.Provider = provider;
            return oBuilder.ToString();
        }
    }
}